procedure kurvp1(n: integer; var x,y: REALDATA; sigma:real;
                 var xp,yp: REALDATA; var s: real);
{naar A.K. Cline, Comm. ACM 4 (1972) 220}
var nm1,np1,i,ip1,ibak: integer;
    delx1,delx2,dels1,dx1,dy1,dely1,dely2,dels2,dx2,dy2,
    sigmap,exps,sinhs,sinhin,diag1,diag2,diagin,spdig1,spdiag,dels: extended;
    temp: array[1..NMAX] of extended;

begin {kurvp1}
     nm1:=n-1; np1:=n+1;
     delx1:=x[2]-x[1]; dely1:=y[2]-y[1];
     dels1:=sqrt(sqr(delx1)+sqr(dely1));
     dx1:=delx1/dels1; dy1:=dely1/dels1;
     xp[1]:=dx1; yp[1]:=dy1;
     temp[1]:=dels1; s:=dels1;
     for i:=2 to n do
         begin if i=n then ip1:=1 else ip1:=i+1;
               delx2:=x[ip1]-x[i]; dely2:=y[ip1]-y[i];
               dels2:=sqrt(sqr(delx2)+sqr(dely2));
               dx2:=delx2/dels2; dy2:=dely2/dels2;
               xp[i]:=dx2-dx1; yp[i]:=dy2-dy1;
               temp[i]:=dels2;
               delx1:=delx2; dely1:=dely2; dels1:=dels2;
               dx1:=dx2; dy1:=dy2;
               s:=s+dels1
         end;
     xp[1]:=xp[1]-dx1; yp[1]:=yp[1]-dy1;

     sigmap:=abs(sigma)*(n/s);

     dels:=sigmap*temp[n]; exps:=exp(dels);
     sinhs:=0.5*(exps-1/exps);
     sinhin:=1/(temp[n]*sinhs);
     diag1:=sinhin*(dels*0.5*(exps+1/exps)-sinhs);
     diagin:=1/diag1;
     spdig1:=sinhin*(sinhs-dels);
     spdiag:=0;
     for i:=1 to n do
         begin dels:=sigmap*temp[i];
               exps:=exp(dels);
               sinhs:=0.5*(exps-1/exps);
               sinhin:=1/(temp[i]*sinhs);
               diag2:=sinhin*(dels*(0.5*(exps+1/exps))-sinhs);
               if i=1 then begin diagin:=1/(diag1+diag2);
                                  xp[1]:=diagin*xp[1];
                                  yp[1]:=diagin*yp[1];
                                  temp[n+1]:=0;
                                  temp[np1]:=-diagin*spdig1;
                                  spdiag:=sinhin*(sinhs-dels);
                                  temp[1]:=diagin*spdiag;
                                  diag1:=diag2
                            end;
               if (i<n) and (i>1) then
                            begin diagin:=1/(diag1+diag2-spdiag*temp[i-1]);
                                  xp[i]:=diagin*(xp[i]-spdiag*xp[i-1]);
                                  yp[i]:=diagin*(yp[i]-spdiag*yp[i-1]);
                                  temp[n+i]:=-diagin*temp[nm1+i]*spdiag;
                                  spdiag:=sinhin*(sinhs-dels);
                                  temp[i]:=diagin*spdiag;
                                  diag1:=diag2
                            end
         end;
     temp[nm1]:=temp[n+nm1]-temp[nm1];
     if n<>2 then for i:=3 to n do
                      begin ibak:=np1-i;
                            xp[ibak]:=xp[ibak]-temp[ibak]*xp[ibak+1];
                            yp[ibak]:=yp[ibak]-temp[ibak]*yp[ibak+1];
                            temp[ibak]:=temp[ibak+n]-temp[ibak]*temp[ibak+1]
                      end;
     xp[n]:=(xp[n]-spdig1*xp[1]-spdiag*xp[nm1])/(diag1+diag2+
             spdig1*temp[1]+spdiag*temp[nm1]);
     yp[n]:=(yp[n]-spdig1*yp[1]-spdiag*yp[nm1])/(diag1+diag2+
             spdig1*temp[1]+spdiag*temp[nm1]);
     for i:=1 to nm1 do
         begin xp[i]:=xp[i]+temp[i]*xp[n];
               yp[i]:=yp[i]+temp[i]*yp[n]
         end;
end {kurvp1};

procedure kurvp2(t,s,sigma: real; n: integer; var x,y,xp,yp: REALDATA;
                 var xs,ys: real);
{naar A.K. Cline, Comm. ACM 4 (1974) 220}
{zonder de voorziening voor grotere efficiency bij herhaald aanroepen}
var sigmap,tn,sum,delx,dely,dels,del1,del2,exps,exps1,sinhd1,sinhd2,
    sinhs,savesum,sumdels: extended;
    i1,i,im1: integer;
    flag: boolean;

begin {kurvp2}
     sigmap:=abs(sigma)*(n/s);
     tn:=abs(t*s);
     i:=2; sum:=0;
     repeat delx:=x[i]-x[i-1];
            dely:=y[i]-y[i-1];
            dels:=sqrt(sqr(delx)+sqr(dely));
            sumdels:=sum+dels;
            flag:=sumdels>=tn;
            savesum:=sum;
            sum:=sumdels; i:=i+1
     until  flag or (i=n+1);
     if flag then begin sum:=savesum;
                        i:=i-1;
                        im1:=i-1
                  end
             else begin i:=1;
                        im1:=n;
                        dels:=s-sum
                  end;

     del1:=tn-sum; del2:=dels-del1;
     exps1:=exp(sigmap*del1);
     sinhd1:=0.5*(exps1-1/exps1);
     exps:=exp(sigmap*del2);
     sinhd2:=0.5*(exps-1/exps);
     exps:=exps1*exps;
     sinhs:=0.5*(exps-1/exps);
     xs:=(xp[i]*sinhd1+xp[im1]*sinhd2)/sinhs+
         ((x[i]-xp[i])*del1+(x[im1]-xp[im1])*del2)/dels;
     ys:=(yp[i]*sinhd1+yp[im1]*sinhd2)/sinhs+
         ((y[i]-yp[i])*del1+(y[im1]-yp[im1])*del2)/dels;
end {kurvp2};
