PROGRAM somverschil;

USES Dos, Crt, GritN, cmstuf;

CONST
     BORDER_COLOR = LightGray;

     A_COLOR = LightCyan;
     B_COLOR = LightMagenta;
     SUM_COLOR = LightGreen {White};
     A_MIN_B_COLOR = LightGreen;
     B_MIN_A_COLOR = LightGreen {LightRed};
     DIF_COLOR = LightGreen {LightBlue};

     DEFINE_VIEW_XMIN = 0.00;
     DEFINE_VIEW_YMIN = 0.24;
     DEFINE_VIEW_XMAX = 0.63;
     DEFINE_VIEW_YMAX = 0.69;

     SUM_VIEW_XMIN = 0.00;
     SUM_VIEW_YMIN = 0.00;
     SUM_VIEW_XMAX = 0.30;
     SUM_VIEW_YMAX = 0.21;

     DIF_VIEW_XMIN = 0.33;
     DIF_VIEW_YMIN = 0.00;
     DIF_VIEW_XMAX = 0.63;
     DIF_VIEW_YMAX = 0.21;

     A_MIN_B_VIEW_XMIN = 0.66;
     A_MIN_B_VIEW_YMIN = 0.48;
     A_MIN_B_VIEW_XMAX = 0.99;
     A_MIN_B_VIEW_YMAX = 0.69;

     B_MIN_A_VIEW_XMIN = 0.66;
     B_MIN_A_VIEW_YMIN = 0.24;
     B_MIN_A_VIEW_XMAX = 0.99;
     B_MIN_A_VIEW_YMAX = 0.45;

     WINDOW_XMIN = -30;
     WINDOW_YMIN = -20;
     WINDOW_XMAX = 30;
     WINDOW_YMAX = 20;

     MAX_POINTS = 100;

     A_FIGUUR = 1;
     B_FIGUUR = 2;

     INCLUDE = 1;
     EXCLUDE = 2;

TYPE
    T_DEF_COORD         = ARRAY[1..MAX_POINTS] OF REAL;
    T_LINE              = RECORD
                                bx, by, ex, ey : REAL;
                          END;
    T_LINE_LIST_PTR     = ^T_LINE_LIST;
    T_LINE_LIST         = RECORD
                                line: T_LINE;
                                prev: T_LINE_LIST_PTR;
                          END;
VAR
   a_x, a_y, b_x, b_y:         T_DEF_COORD;
   ab_port, sum_port, dif_port:INTEGER;
   aminb_port, bmina_port:     INTEGER;
   a_points, b_points:         INTEGER;
   eind:                       BOOLEAN;
   c:                          BYTE;
   a_list, b_list:             T_LINE_LIST_PTR;


PROCEDURE CreateViewports;
BEGIN
     SetViewport(DEFINE_VIEW_XMIN, DEFINE_VIEW_YMIN, DEFINE_VIEW_XMAX,
                 DEFINE_VIEW_YMAX, BORDER_COLOR);
     SetWindow(WINDOW_XMIN, WINDOW_YMIN, WINDOW_XMAX, WINDOW_YMAX);
     ab_port := StoreView(0);

     SetViewport(SUM_VIEW_XMIN, SUM_VIEW_YMIN, SUM_VIEW_XMAX,
                 SUM_VIEW_YMAX, BORDER_COLOR);
     SetWindow(WINDOW_XMIN, WINDOW_YMIN, WINDOW_XMAX, WINDOW_YMAX);
     sum_port := StoreView(0);

     SetViewport(DIF_VIEW_XMIN, DIF_VIEW_YMIN, DIF_VIEW_XMAX,
                 DIF_VIEW_YMAX, BORDER_COLOR);
     SetWindow(WINDOW_XMIN, WINDOW_YMIN, WINDOW_XMAX, WINDOW_YMAX);
     dif_port := StoreView(0);

     SetViewport(A_MIN_B_VIEW_XMIN, A_MIN_B_VIEW_YMIN, A_MIN_B_VIEW_XMAX,
                 A_MIN_B_VIEW_YMAX, BORDER_COLOR);
     SetWindow(WINDOW_XMIN, WINDOW_YMIN, WINDOW_XMAX, WINDOW_YMAX);
     aminb_port := StoreView(0);

     SetViewport(B_MIN_A_VIEW_XMIN, B_MIN_A_VIEW_YMIN, B_MIN_A_VIEW_XMAX,
                 B_MIN_A_VIEW_YMAX, BORDER_COLOR);
     SetWindow(WINDOW_XMIN, WINDOW_YMIN, WINDOW_XMAX, WINDOW_YMAX);
     bmina_port := StoreView(0);
END;

PROCEDURE ClearViewports;
BEGIN
     IF UseView(ab_port) THEN;
     ClearViewport;
     ab_port := StoreView(ab_port);

     IF UseView(sum_port) THEN;
     Clearviewport;
     sum_port := StoreView(sum_port);

     IF UseView(dif_port) THEN;
     Clearviewport;
     dif_port := StoreView(dif_port);

     IF Useview(aminb_port) THEN;
     ClearViewport;
     aminb_port := StoreView(aminb_port);

     IF UseView(bmina_port) THEN;
     ClearViewport;
     bmina_port := StoreView(bmina_port);
END;

PROCEDURE DefinePolygon(VAR xar, yar : T_DEF_COORD;
                        VAR points : INTEGER; color : INTEGER);
VAR
    i:      INTEGER;
    eind:   BOOLEAN;
    x, y:   REAL;
    px, py: REAL;
    button: INTEGER;
BEGIN
    x := 0.0;
    y := 0.0;
    i := 1;
    eind := FALSE;
    WHILE NOT eind DO
       BEGIN
         Locator(x, y, button);
         Prompt('');
         if (button<>2) then
            begin
               Marker(x, y, cross, color);
               IF i > 1 THEN
               Drawline(px, py, x, y, color);
               px := x;
               py := y;
               xar[i] := x;
               yar[i] := y;
               IF i > 1 THEN
                 begin
                   if (xar[i]<>xar[i-1]) or (yar[i]<>yar[i-1]) then
                     i:=i+1
                 end
               ELSE
                 i:=i+1
            end;
         eind:=(i = MAX_POINTS) or ((button = 2) AND (i > 2))
       END;

     { APPEND THE FIRST POINT }
     xar[i] := xar[1];
     yar[i] := yar[1];
    points := i;
    Polyline(@xar, @yar, points, color, CLOSED);
END;

PROCEDURE DefinePolygons;
BEGIN
     IF UseView(ab_port) THEN;

     Prompt('Click polygon A. Right-click AFTER the last point');
     DefinePolygon(a_x, a_y, a_points, A_COLOR);
     Prompt('Click polygon B. Right-click AFTER the last point');
     DefinePolygon(b_x, b_y, b_points, B_COLOR);
     Prompt('');
     ClearViewport;
     Polyline(@a_x, @a_y, a_points, A_COLOR, CLOSED);
     Polyline(@b_x, @b_y, b_points, B_COLOR, CLOSED);
     GraphText(WINDOW_XMIN,WINDOW_YMIN,'A',A_COLOR);
     GraphText(WINDOW_XMIN+2,WINDOW_YMIN,'B',B_COLOR);

     ab_port := StoreView(ab_port);
END;

PROCEDURE BepaalBox(VAR xmin, ymin, xmax, ymax : REAL; px, py:T_DEF_COORD;
                                          points:INTEGER);
VAR i : integer;
BEGIN
     xmin := px[1]; xmax := px[1];
     ymin := py[1]; ymax := py[1];
     FOR i := 2 TO points DO
     BEGIN
          IF (px[i] < xmin) THEN
             xmin := px[i];
          IF (px[i] > xmax) THEN
             xmax := px[i];
          IF (py[i] < ymin) THEN
             ymin := py[i];
          IF (py[i] > ymax) THEN
             ymax := py[i];
     END;
END;

FUNCTION InBox(x, y : real; px, py : T_DEF_COORD;
            points : INTEGER; VAR xmax: REAL) : boolean;
VAR xmin, ymin, ymax : real;
BEGIN
     BepaalBox(xmin, ymin, xmax, ymax, px, py, points);
     IF (x >= xmin) AND (x <= xmax) AND (y >= ymin) AND (y <= ymax) THEN
        InBox := TRUE
     ELSE
        InBox := FALSE;
END;

FUNCTION Crosses(l1, l2: T_LINE; VAR sx, sy : REAL) : BOOLEAN;
VAR
   b1, r1 : REAL;
   b2, r2 : REAL;
   ret : BOOLEAN;
BEGIN
     ret := TRUE;
     IF (l1.bx = l1.ex) OR (l2.bx = l2.ex) THEN
     BEGIN
          IF (l1.bx = l1.ex) AND (l2.bx = l2.ex) THEN
             ret := FALSE;
          IF (l1.bx = l1.ex) AND (l2.bx <> l2.ex) THEN
          BEGIN
               r2 := (l2.by - l2.ey) / (l2.bx - l2.ex);
               b2 := l2.by - r2*l2.bx;
               sx := l1.bx;
               sy := r2*l1.bx + b2;
          END;
          IF (l1.bx <> l1.ex) AND (l2.bx = l2.ex) THEN
          BEGIN
               r1 := (l1.by - l1.ey) / (l1.bx - l1.ex);
               b1 := l1.by - r1*l1.bx;
               sx := l2.bx;
               sy := r1*l2.bx + b1;
          END;
     END
     ELSE
     BEGIN
          r1 := (l1.by - l1.ey) / (l1.bx - l1.ex);
          b1 := l1.by - r1*l1.bx;

          r2 := (l2.by - l2.ey) / (l2.bx - l2.ex);
          b2 := l2.by - r2*l2.bx;
          IF r1 = r2 THEN
             ret := FALSE
          ELSE
          BEGIN
               sx := (b2 - b1) / (r1 - r2);
               sy := r1*sx + b1;
          END;
     END;
     IF ret THEN
     BEGIN
          IF ((l1.bx <> l1.ex) AND (sx >= l1.bx) AND (sx >= l1.ex)) OR
             ((l1.bx <> l1.ex) AND (sx <= l1.bx) AND (sx <= l1.ex)) OR
             ((l2.bx <> l2.ex) AND (sx >= l2.bx) AND (sx >= l2.ex)) OR
             ((l2.bx <> l2.ex) AND (sx <= l2.bx) AND (sx <= l2.ex)) OR
             ((l1.by <> l1.ey) AND (sy >= l1.by) AND (sy >= l1.ey)) OR
             ((l1.by <> l1.ey) AND (sy <= l1.by) AND (sy <= l1.ey)) OR
             ((l2.by <> l2.ey) AND (sy >= l2.by) AND (sy >= l2.ey)) OR
             ((l2.by <> l2.ey) AND (sy <= l2.by) AND (sy <= l2.ey)) THEN
                  ret := FALSE;
     END;
     Crosses := ret;
END;

FUNCTION CrosNumber(x, y:REAL; px, py: T_DEF_COORD;
                            points:INTEGER; xmax : REAL) : INTEGER;
VAR i, prev : INTEGER;
sx, sy : REAL;
count : INTEGER;
line1, line2: T_LINE;
BEGIN
     count := 0;
     FOR i:= 1 TO points - 1 DO
     BEGIN
          line1.bx := x; line1.by := y; line1.ex := xmax; line1.ey := y;
          line2.bx := px[i]; line2.by := py[i];
          line2.ex := px[i + 1]; line2.ey := py[i + 1];
          IF Crosses(line1, line2, sx, sy) THEN
          BEGIN
             IF (sx = px[i]) AND (sy = py[i]) THEN
             BEGIN
                  IF i = 1 THEN prev := points - 1
                  ELSE prev := i - 1;
                  IF ((py[i] > py[i + 1]) AND (py[i] > py[prev])) OR
                          ((py[i] < py[i + 1]) AND (py[i] < py[prev])) THEN
                          count := count + 1;
             END
             ELSE
                 count := count + 1;
          END;
     END;
     CrosNumber := count;
END;

FUNCTION InPoly(x, y: REAL; px, py : T_DEF_COORD; points : INTEGER) : BOOLEAN;
VAR
    cros : INTEGER;
    xmax : REAL;
BEGIN
    IF NOT InBox(x, y, px, py, points, xmax) THEN
      InPoly := FALSE
    ELSE
    BEGIN
        cros := CrosNumber(x, y, px, py, points, xmax);
        IF (cros MOD 2 = 0) THEN
            InPoly := FALSE
        ELSE
            InPoly := TRUE;
    END;
END;

PROCEDURE BepaalMidden(line:T_LINE; VAR mx, my: REAL);
BEGIN
        mx := (line.bx + line.ex) / 2;
        my := (line.by + line.ey) / 2;
END;

PROCEDURE DrawLines(figuur: INTEGER; px, py: T_DEF_COORD;
                                points, mode, color: INTEGER);
VAR
   tmp: T_LINE_LIST_PTR;
   mx, my: REAL;
   inpol: BOOLEAN;
   ade:BYTE;
BEGIN
     IF figuur = A_FIGUUR THEN
        tmp := a_list
     ELSE
         tmp := b_list;
     WHILE tmp <> nil DO
     BEGIN
          BepaalMidden(tmp^.line, mx, my);
          inpol := InPoly(mx, my, px, py, points);
          IF ((mode = EXCLUDE) AND (NOT inpol)) OR
             ((mode = INCLUDE) AND inpol) THEN
                    BEGIN
                    Drawline(tmp^.line.bx, tmp^.line.by,
                              tmp^.line.ex, tmp^.line.ey, color);
                    END;
          tmp := tmp^.prev;
     END;
END;

PROCEDURE Sum;
VAR
        i : INTEGER;
BEGIN
    IF UseView(sum_port) THEN;
    GraphText(WINDOW_XMIN,WINDOW_YMIN,'A+B',SUM_COLOR);
    DrawLines(A_FIGUUR, b_x, b_y, b_points, EXCLUDE, SUM_COLOR);
    DrawLines(B_FIGUUR, a_x, a_y, a_points, EXCLUDE, SUM_COLOR);
    sum_port := StoreView(sum_port);
END;

PROCEDURE Dif;
VAR
        i : INTEGER;
BEGIN
    IF UseView(dif_port) THEN;
    GraphText(WINDOW_XMIN,WINDOW_YMIN,'AB',DIF_COLOR);
    DrawLines(A_FIGUUR, b_x, b_y, b_points, INCLUDE, DIF_COLOR);
    DrawLines(B_FIGUUR, a_x, a_y, a_points, INCLUDE, DIF_COLOR);
    dif_port := StoreView(dif_port);
END;

PROCEDURE AMinB;
BEGIN
     IF UseView(aminb_port) THEN;
     GraphText(WINDOW_XMIN,WINDOW_YMIN,'A-B',A_MIN_B_COLOR);
     DrawLines(A_FIGUUR, b_x, b_y, b_points, EXCLUDE, A_MIN_B_COLOR);
     DrawLines(B_FIGUUR, a_x, a_y, a_points, INCLUDE, A_MIN_B_COLOR);
     aminb_port := StoreView(aminb_port);
END;

PROCEDURE BMinA;
BEGIN
     IF UseView(bmina_port) THEN;
     GraphText(WINDOW_XMIN,WINDOW_YMIN,'B-A',B_MIN_A_COLOR);
     DrawLines(A_FIGUUR, b_x, b_y, b_points, INCLUDE, B_MIN_A_COLOR);
     DrawLines(B_FIGUUR, a_x, a_y, a_points, EXCLUDE, B_MIN_A_COLOR);
     bmina_port := StoreView(bmina_port);
END;

PROCEDURE AppendList(figuur: INTEGER; line: T_LINE);
VAR
        tmp: T_LINE_LIST_PTR;
BEGIN
        new(tmp);
        tmp^.line := line;
        IF figuur = A_FIGUUR THEN
        BEGIN
           tmp^.prev := a_list;
           a_list := tmp
        END
        ELSE
        BEGIN
            tmp^.prev := b_list;
            b_list := tmp;
        END;
END;

FUNCTION Delta(x, y, x2, y2: REAL): REAL;
BEGIN
   Delta := Sqrt(Sqr(y2 - y) + Sqr(x2 - x));
END;

FUNCTION FindCrossing(VAR line, nline: T_LINE; px, py: T_DEF_COORD; points: INTEGER): BOOLEAN;
VAR
   i: INTEGER;
   cx, cy: REAL;
   tx, ty: REAL;
   cline: T_LINE;
BEGIN
     cx := line.ex;
     cy := line.ey;
     FOR i := 1 TO points - 1 DO
     BEGIN
          cline.bx := px[i];
          cline.by := py[i];
          cline.ex := px[i + 1];
          cline.ey := py[i + 1];
          IF Crosses(line, cline, tx, ty) AND
                           ((tx <> line.bx) OR (ty <> line.by)) THEN
          BEGIN
               IF Delta(line.bx, line.by, tx, ty) <
                                 Delta(line.bx, line.by, cx, cy) THEN
               BEGIN
                    cx := tx;
                    cy := ty;
               END;
          END;
     END;
     IF (cx = line.ex) AND (cy = line.ey) THEN
     BEGIN
          FindCrossing := FALSE;
          nline := line;
     END
     ELSE
     BEGIN
          FindCrossing := TRUE;
          nline.ex := line.ex;
          nline.ey := line.ey;
          nline.bx := cx;
          nline.by := cy;
          line.ex := cx;
          line.ey := cy;
     END;
END;

PROCEDURE BuildList(px, py:T_DEF_COORD; points: INTEGER;
                            px2, py2: T_DEF_COORD; points2: INTEGER;
                            figuur: INTEGER);
VAR
   i: INTEGER;
   line, nline: T_LINE;
   cx, cy: REAL;
BEGIN
     FOR i := 1 TO points - 1 DO
     BEGIN
          line.bx := px[i];
          line.by := py[i];
          line.ex := px[i + 1];
          line.ey := py[i + 1];
          WHILE FindCrossing(line, nline, px2, py2, points2) DO
          BEGIN
                AppendList(figuur, line);
                line := nline;
          END;
          AppendList(figuur, nline);
     END;
END;

PROCEDURE FreeLists;
VAR
    tmp: T_LINE_LIST_PTR;
BEGIN
     WHILE a_list <> nil DO
     BEGIN
          tmp := a_list;
          a_list := a_list^.prev;
          Dispose(tmp);
     END;
     WHILE b_list <> nil DO
     BEGIN
          tmp := b_list;
          b_list := b_list^.prev;
          Dispose(tmp);
     END;
END;

BEGIN
     hello('Program 11',
           'Set operations on polygons',
           'uk');
     a_list := nil;
     b_list := nil;
     SetupGraphics;
     CreateViewports;
     eind := FALSE;
     REPEAT
           ClearViewports;
           DefinePolygons;
           BuildList(a_x, a_y, a_points, b_x, b_y, b_points, A_FIGUUR);
           BuildList(b_x, b_y, b_points, a_x, a_y, a_points, B_FIGUUR);
           Sum;
           Dif;
           AMinB;
           BMinA;
           Prompt('<space> for going on, <s> to stop');
           Wait(-1, c);
           IF (c = ORD('s')) OR (c = ORD('S')) THEN
              eind := TRUE;
           Prompt('');
           FreeLists;
     UNTIL eind;

     DoneGraphics;
END.
