{$N+}

UNIT GritN;
{E.H. Dooijes ---University of Amsterdam} 
{publ version nov 2015}

INTERFACE

uses Graph,Dos,Crt;

const version_id='GRIT (VGA version) / Nov 7, 2015';
      closed   =true;
      nonclosed=false;
      absolut=true;
      relativ=false;
      BackColor=0;
      blue     =1; lightblue   =9;
      green    =2; lightgreen  =10;
      cyan     =3; lightcyan   =11;
      red      =4; lightred    =12;
      magenta  =5; lightmagenta=13;
      brown    =6; yellow      =14;
      lightgray=7; darkgray    =8;
      black   =16; white       =15;
      fcircle  =7;  ocircle  =9;
      ftriangle=30; otriangle=127;
      fsquare  =219;osquare  =8;
      fdiamond =4;  odiamond =233;
      plus     =43;
      cross    =120;
      asterisk =42;
      dot      =254;
      star     =15;
      pixel    =0;
      VGA         =Graph.VGA;
      OverWrite=0;
      ExclOr   =1;
      ButtColor  :integer=yellow;

type VEC3 =array[1..3] of real;
     MAT33=array[1..3,1..3] of real;
     VEC4 =array[1..4] of real;
     MAT44=array[1..4,1..4] of real;
     ButtTxtArr=array[1..8] of string[20];

procedure DoneGraphics;
procedure Error(msg:string);
procedure SetUpGraphics;
procedure SetViewport(xmin,ymin,xmax,ymax:real;box:integer);
procedure ClearViewport;
procedure RemoveViewport;
procedure SetWindow(xmin,ymin,xmax,ymax:real);
procedure DrawLine(x1,y1,x2,y2:real;color:integer);
procedure ArrowLine(x1,y1,x2,y2:real;color:integer);
procedure Polyline(xPtr,yPtr:pointer;n,color:integer;close_polygon:boolean);
procedure FillArea(xPtr,yPtr:pointer;n,color:integer);
procedure Marker(x,y:real;mark:byte;color:integer);
procedure Locator(var x,y:real;var button:integer);
procedure Wait(seconds:real;var ade:byte);
procedure SetBackground(color:integer);
procedure GraphText(x,y:real;s:string;color:integer);
function  IntToString(i:longint):string;
function  RealToString(i:real):string;
procedure Beep(snd:integer);
procedure DefineButtons(texts:ButtTxtArr);
procedure RemoveButtons;
function  ReadButton(var result:integer):integer;
procedure Prompt(PromptStr:string);
procedure Response(RespStr:string);
function  ReadReal:real;
function  ReadInteger:integer;
function  ReadString:string;
function  StoreView(ViewID:integer):integer;
function  UseView(ViewID:integer):boolean;
procedure WritePixel(ix,iy,color:integer);
procedure PlotPixel(x,y:real;color:integer);
procedure U2P(x,y:real;var ix,iy:integer;absol:boolean);
procedure P2U(ix,iy:integer;var x,y:real;absol:boolean);
procedure SetMarkerMode(mode:integer);
procedure SetDrawMode(mode:integer);
procedure SetFillMode(mode:integer);
procedure SetGraphtextMode(mode:integer);
procedure SetPaletEntry(WhichPalette,index:integer;rd,gr,bl:byte);
procedure LoadPalette(WhichPalette:integer);
procedure ReadPalette(WhichPalette,index:integer;var rd,gr,bl:byte);
procedure ShowVersion(var s:string);


IMPLEMENTATION

const VERTMAX=677;

type GrafBounds=record Top,Bottom,Right,Left:integer end;
     polypoint=record x,y:integer end;
     ViewStruct=record SAX,SAY,SBX,SBY:real;
                       SLeft,SBottom,SRight,STop:integer;
                       SBoxColor:integer;
                       OnScreen,active:boolean;
                       xmin,ymin,xmax,ymax:real;
                end;
     CsrShpArr=array[1..2,1..32]of byte;

var bottomScr,rightScr:integer;
    GrBounds:GrafBounds;
    ErrorCode:integer;
    BoxColor:integer;
    punt:array[1..VERTMAX] of polypoint;
    VpFlag:boolean;
    BeepSound,ResponsPos:integer;
    OldPrmptStr,OldRespStr:string;
    ButtonTexts:ButtTxtArr;
    LastViewID,SpecialViewID:integer;
    ViewRecArr:array[1..10] of ViewStruct;
    WindowBounds:record xmi,ymi,xma,yma:real end;
    AX,BX,AY,BY:real;
    RespDone:boolean;
    MouseAvailable,UseArrowkeys:boolean;
    MarkerMode,
    GraphTextMode,
    DrawMode:integer;
    SVGAmode,
    origmode,
    NumColors:integer;
    Palettes:array[0..2]of record length:word; (* MW -- for Grit8514 *)
                                  data  :array[0..256,0..2]of byte;
                           end;
    intime: longint;
    igeduld: integer;

const OldMouseX:integer=-1;
      OldMouseY:integer=-1;


procedure ShowVersion;
begin
  s:=version_id
end;


procedure mydelay(msec:integer); {alleen gebruikt in readbuttons}
var h,m,s,c:word;
    t1,t2:longint;
begin
  if msec<55 then
    delay(msec)
  else
    begin
      GetTime(h,m,s,c);
      t1:=c+100*(s+60*(m+60*h));
      repeat
        GetTime(h,m,s,c);
        t2:=c+100*(s+60*(m+60*h));
      until t2-t1>msec/10
    end
end;


procedure time_in;
begin
end;

procedure time_out(sec:integer);
begin
end;

procedure mouse(var m1,m2,m3,m4,m5:word);
var regs:registers;
begin
  with regs do begin AX:=m1; BX:=m2; CX:=m3; DX:=m4; ES:=m5 end;
  intr($33,regs);
  with regs do begin m1:=AX; m2:=BX; m3:=CX; m4:=DX; m5:=ES end
end;

procedure PutMouse(x,y:real);
var m1,m2,m3,m4,m5:word;
begin
  U2P(x,y,integer(m3),integer(m4),absolut);
  m1:=4; mouse(m1,m2,m3,m4,m5);
  m1:=1; mouse(m1,m2,m3,m4,m5);
  OldMouseX:=m3;
  OldMouseY:=m4
end;

procedure HideMouse;
var m1,m2,m3,m4,m5:word;
begin
  m1:=2; mouse(m1,m2,m3,m4,m5)
end;

procedure CheckIfInWindow(var x,y:real);
var inside:boolean;
begin
  with WindowBounds do
    begin
      inside:=(x>=xmi) and (x<=xma) and (y>=ymi) and (y<=yma);
      if not inside then
        begin
          x:=(xmi+xma)/2;
          y:=(ymi+yma)/2
        end
    end
end;

procedure DoneGraphics;
begin
  CloseGraph;
  Textmode(origmode)
end;

procedure Error;
begin
  if ErrorCode<>0 then
    begin
      DoneGraphics;
      writeln(GraphErrorMsg(ErrorCode));
      halt
    end;
  if msg<>'SystemError' then
    begin
      DoneGraphics;
      writeln(msg);
      halt
    end
end;

procedure CopyDefaultPalette(WhichPalette:byte);
const cidata:array[0..15,0..2] of byte=
       (( 0, 0, 0),( 0, 0,42),( 0,42, 0),( 0,42,42),
        (42, 0, 0),(42, 0,42),(42,21, 0),(42,42,42),
        (21,21,21),( 0, 0,63),( 0,63, 0),( 0,63,63),
        (63, 0, 0),(63, 0,63),(63,63, 0),(63,63,63));
var i,j:byte;
begin
  for i:=0 to 15 do
    for j:=0 to 2 do
      Palettes[WhichPalette].data[i][j]:=cidata[i][j]
end;


procedure SetUpGraphics;
var i:integer;
    m1,m2,m3,m4,m5:word;
    Graphdriver,Graphmode: integer;
begin
  origmode:=LastMode;
  NumColors:=16;
  Graphdriver:=VGA;
  Graphmode:=VGAhi;
  InitGraph(Graphdriver,Graphmode,'');
  rightScr:=GetMaxX; bottomScr:=GetMaxY;
  SetLineStyle(SolidLn,0,NormWidth);
  m1:=0; mouse(m1,m2,m3,m4,m5);
  BoxColor:=0;
  VpFlag:=false;
  BeepSound:=0;
  LastViewID:=0;
  OldPrmptStr:='';
  OldRespStr:='';
  SpecialViewID:=0;
  for i:=1 to 10 do ViewRecArr[i].active:=false;
  for i:=1 to 8 do ButtonTexts[i]:='';
  RespDone:=true;
  SetMarkerMode(Overwrite);
  SetGraphTextMode(OverWrite);
  SetDrawMode(OverWrite);
  CopyDefaultPalette(0);
  LoadPalette(0);
  for i:=0 to NumColors-1 do SetPalette(i,i);
end;

procedure SetBackground;
begin
  SetBkColor(color);
end;

procedure BoxBorder;
begin
  SetWriteMode(Copyput);
  with GrBounds do
    begin
      if (BoxColor<>BackColor) and (BoxColor<>black) then
        begin
          if Left  >0         then Left  :=Left  -1;
          if Top   >0         then Top   :=Top   -1;
          if Right <rightScr  then Right :=Right +1;
          if Bottom<bottomScr then Bottom:=Bottom+1
        end;
      Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);
      if (BoxColor<>BackColor) and (BoxColor<>black) then
        begin
          SetColor(BoxColor);
          Rectangle(0,0,Right-Left,Bottom-Top);
          Left:=Left+1; Right :=Right-1;
          Top :=Top+1;  Bottom:=Bottom-1;
          Graph.SetViewport(Left,Top,Right,Bottom,ClipOn)
        end
    end;
  SetWriteMode(DrawMode)
end;

procedure SetViewport;
begin
  if(xmin>=xmax) or (ymin>=ymax) then Error('illegal viewport specification');
  VpFlag:=true;
  with GrBounds do
    begin
      Left:=trunc(xmin*rightScr);
      Right:=trunc(xmax*rightScr);
      Bottom:=trunc(bottomScr-ymin*rightScr);
      Top:=trunc(bottomScr-ymax*rightScr);
      if (Left<0) or (Right>rightScr) or (Bottom>bottomScr) or (Top<0) then
        Error('viewport exceeds screen boundaries')
    end;
  BoxColor:=box;
  BoxBorder
end;

procedure ClearViewport;
begin
  Graph.ClearViewport;
  BoxBorder
end;

procedure RemoveViewport;
begin
  with GrBounds do
    begin
      if (BoxColor<>BackColor) and (BoxColor<>black) then
        begin
          if Left  >0         then Left  :=Left  -1;
          if Top   >0         then Top   :=Top   -1;
          if Right <rightScr  then Right :=Right +1;
          if Bottom<bottomScr then Bottom:=Bottom+1
        end;
      Graph.SetViewport(Left,Top,Right,Bottom,ClipOn)
    end;
  Graph.ClearViewport
end;

procedure SetWindow;
begin
  if not VpFlag then Error('missing viewport specification');
  if(xmin>=xmax) or (ymin>=ymax) then Error('illegal window specification');
  with Grbounds do
    begin
      AX:=(Left-Right)/(xmin-xmax); BX:=-AX*xmin;
      AY:=(Top-Bottom)/(ymax-ymin); BY:=-AY*ymax
    end;
  with WindowBounds do begin xmi:=xmin; ymi:=ymin; xma:=xmax; yma:=ymax end;
end;

procedure U2P;
begin
  with GrBounds do
    if absol then begin ix:=round(AX*x+BX)+Left; iy:=round(AY*y+BY)+Top end
             else begin ix:=round(AX*x+BX);      iy:=round(AY*y+BY) end
end;

procedure P2U;
begin
  with GrBounds do
    if absol then begin x:=(ix-BX-Left)/AX; y:=(iy-BY-Top)/AY end
             else begin x:=(ix-BX     )/AX; y:=(iy-BY    )/AY end
end;

procedure DrawLine;
var ix1,iy1,ix2,iy2:integer;
begin
  U2P(x1,y1,ix1,iy1,relativ);
  U2P(x2,y2,ix2,iy2,relativ);
  SetColor(color);
  Line(ix1,iy1,ix2,iy2);
end;

procedure ArrowLine;
var xa,ya,xb,yb,xa1,ya1,mu,mu1,phi,len:real;

  procedure draai(phi,x,y:real;var xd,yd:real);
  var xx,yy:real;
  begin
    phi:=phi*pi/180;
    x:=x-xa; y:=y-ya;
    xx:=x*cos(phi)-y*sin(phi);
    yy:=x*sin(phi)+y*cos(phi);
    xd:=xx+xa; yd:=yy+ya
  end;

begin
  len:=10/AX;
  DrawLine(x1,y1,x2,y2,color);
  mu:=0.8;
  phi:=150;
  mu1:=mu+len/sqrt(sqr(x2-x1)+sqr(y2-y1));
  xa:=x1+mu*(x2-x1);
  ya:=y1+mu*(y2-y1);
  xa1:=x1+mu1*(x2-x1);
  ya1:=y1+mu1*(y2-y1);
  draai(phi,xa1,ya1,xb,yb);
  DrawLine(xa,ya,xb,yb,color);
  DrawLine(xa,ya,xb,yb,color);
  draai(-phi,xa1,ya1,xb,yb);
  DrawLine(xa,ya,xb,yb,color);
end;

procedure Polyline;
var i:integer;
    segmx,offsx,segmy,offsy:word;
    xp,yp:^real;
begin
  if n>VERTMAX then Error('too much vertices in Polyline');
  segmx:=Seg(xPtr^); offsx:=Ofs(xPtr^);
  segmy:=Seg(yPtr^); offsy:=Ofs(yPtr^);
  for i:=1 to n do
    begin
      xp:=Ptr(segmx,offsx+(i-1)*sizeof(real));
      yp:=Ptr(segmy,offsy+(i-1)*sizeof(real));
      U2P(xp^,yp^,punt[i].x,punt[i].y,relativ)
    end;
  if close_polygon then begin n:=n+1; punt[n]:=punt[1] end;
  SetColor(color);
  DrawPoly(n,punt)
end;

procedure FillArea;
var i:integer;
    segmx,offsx,segmy,offsy:word;
    xp,yp:^real;
    pattern,fillcolor:word;
begin
  if n>VERTMAX then Error('too much vertices in FillArea');
  segmx:=Seg(xPtr^); offsx:=Ofs(xPtr^);
  segmy:=Seg(yPtr^); offsy:=Ofs(yPtr^);
  for i:=1 to n do
    begin
      xp:=Ptr(segmx,offsx+(i-1)*sizeof(real));
      yp:=Ptr(segmy,offsy+(i-1)*sizeof(real));
      U2P(xp^,yp^,punt[i].x,punt[i].y,relativ)
    end;
  if color=0 then begin pattern:=EmptyFill; fillcolor:=0 end
             else begin pattern:=SolidFill; fillcolor:=color end;
  SetColor(color);
  SetFillStyle(pattern,fillcolor);
  FillPoly(n,punt);
end;

procedure Marker;
var ix,iy,ix1,iy1,ix2,iy2,size:integer;
    im:pointer;
begin
  SetColor(color);
  SetTextJustify(CenterText,CenterText);
  U2P(x,y,ix,iy,relativ);
  if (mark=otriangle) or (mark=cross) then iy:=iy-1;
  if MarkerMode=Overwrite then
    if mark=pixel then PutPixel(ix,iy,color)
                  else OutTextXY(ix,iy+1,chr(mark))
  else
    if mark=pixel then begin PutPixel(ix,iy,color xor GetPixel(ix,iy)) end
    else
      begin
        ix1:=ix-4; if ix1<0 then ix1:=0;
        iy1:=iy-4; if iy1<0 then iy1:=0;
        ix2:=ix+5; if ix2>rightScr  then ix2:=rightScr;
        iy2:=iy+5; if iy2>bottomScr then iy2:=bottomScr;
        size:=ImageSize(ix1,iy1,ix2,iy2);
        GetMem(im,size);
        GetImage(ix1,iy1,ix2,iy2,im^);
        PutImage(ix1,iy1,im^,XORput);
        OutTextXY(ix,iy+1,chr(mark));
        PutImage(ix1,iy1,im^,XORput);
        FreeMem(im,size)
      end
end;

procedure WritePixel;
begin
  PutPixel(ix,iy,color);
end;

procedure PlotPixel;
var ix,iy:integer;
begin
  U2P(x,y,ix,iy,relativ);
  PutPixel(ix,iy,color)
end;

procedure GraphText;
var ix,iy,ix1,iy1,size:integer;
    im:pointer;
begin
  SetColor(color);
  SetTextJustify(LeftText,BottomText);
  U2P(x,y,ix,iy,relativ);
  if GraphTextMode=Overwrite then OutTextXY(ix,iy,s)
  else
    begin
      ix1:=ix-1; if ix1<0 then ix1:=0;
      iy1:=iy-9; if iy1<0 then iy1:=0;
      size:=ImageSize(ix1,iy1,GrBounds.Right,iy);
      GetMem(im,size);
      GetImage(ix1,iy1,GrBounds.Right,iy,im^);
      PutImage(ix1,iy1,im^,XORput);
      OutTextXY(ix,iy,s);
      PutImage(ix1,iy1,im^,XORput);
      FreeMem(im,size)
    end
end;

procedure Locator;
var m1,m2,m3,m4,m5:word;
    xm,ym:integer;
begin
  with GrBounds do
    begin
      m1:=7; m3:=Left; m4:=Right;
      mouse(m1,m2,m3,m4,m5);
      m1:=8; m3:=Top; m4:=Bottom;
      mouse(m1,m2,m3,m4,m5)
    end;
  CheckIfInWindow(x,y);
  PutMouse(x,y);
  m1:=3;
  repeat mouse(m1,m2,m3,m4,m5) until m2=0;
  time_in;
  repeat
       mouse(m1,m2,m3,m4,m5);
       time_out(igeduld)
  until m2>0;
  OldMouseX:=m3;
  OldMouseY:=m4;
  button:=m2;
  P2U(m3,m4,x,y,absolut);
  HideMouse;
  if BeepSound>0 then begin sound(BeepSound); delay(100); nosound end;
end;

procedure Wait;
var msec:word;
    m1,m2,m3,m4,m5:word;
    ch:char;
begin
  if seconds>=0 then
    begin
      msec:=round(seconds*1000);
      Delay(msec)
    end
  else if (seconds=-1) then
    begin
      time_in;
      repeat time_out(igeduld) until keypressed;
      ade:=ord(ReadKey)
    end
  else if (seconds=-2) then
    begin
      m1:=3;
      repeat mouse(m1,m2,m3,m4,m5) until m2=0;
      time_in;
      repeat
           mouse(m1,m2,m3,m4,m5);
           time_out(igeduld)
      until m2>0;
      ade:=m2
    end
end;

function IntToString;
var tmpstr:string[10];
begin
  Str(i:0,tmpstr);
  IntToString:=tmpstr;
end;

function RealToString;
var tmpstr:string[20];
begin
  Str(i:0:3,tmpstr);
  RealToString:=tmpstr;
end;

procedure Beep;
begin
  BeepSound:=snd
end;

function StoreView;
begin
  if (ViewID=0) then
    begin
      ViewID:=LastViewID+1;
      LastViewID:=ViewID;
    end;
  if ViewID>10 then StoreView:=0
  else
    begin
      with ViewRecArr[ViewID] do
        begin
          SAX:=AX;
          SAY:=AY;
          SBX:=BX;
          SBY:=BY;
          SLeft:=GrBounds.Left;
          SRight:=GrBounds.Right;
          STop:=GrBounds.Top;
          SBottom:=GrBounds.Bottom;
          SBoxColor:=BoxColor;
          xmin:=WindowBounds.xmi;
          ymin:=WindowBounds.ymi;
          xmax:=WindowBounds.xma;
          ymax:=WindowBounds.yma;
          active:=true
        end;
      StoreView:=ViewID
    end
end;

function UseView;
begin
  if not ViewRecArr[ViewID].active then UseView:=false
  else
    begin
      with ViewRecArr[ViewID] do
        begin
          AX:=SAX;
          AY:=SAY;
          BX:=SBX;
          BY:=SBY;
          GrBounds.Left:=SLeft;
          GrBounds.Right:=SRight;
          GrBounds.Top:=STop;
          GrBounds.Bottom:=SBottom;
          BoxColor:=SBoxColor;
          WindowBounds.xmi:=xmin;
          WindowBounds.ymi:=ymin;
          WindowBounds.xma:=xmax;
          WindowBounds.yma:=ymax;
          if not OnScreen then
            begin
              OnScreen:=true;
              Graph.SetViewport(SLeft,STop,SRight,SBottom,ClipOn);
              BoxBorder;
            end
          else Graph.SetViewport(SLeft,STop,SRight,SBottom,ClipOn);
        end;
      UseView:=true
    end
end;

procedure putbutton(x:integer;txt:string);
var j:integer;
begin
 j:=pos('|',txt+'|');
 if j<length(txt) then
   begin
     OutTextXY(x,14,copy(txt,1,j-1));
     OutTextXY(x,24,copy(txt,j+1,255))
   end
 else
   OutTextXY(x,19,copy(txt,1,j-1))
end;

procedure RemoveButtons;
var i,mx,my,dx,vga30:integer;
begin
  mx:=GetMaxX; my:=GetMaxY;
  dx:=mx div 8;
  vga30:=round(my/16);
  Graph.SetViewport(0,my-vga30,mx,my,ClipOn);
  SetTextJustify(LeftText,BottomText);
  SetColor(BackColor);
  SetWriteMode(Overwrite);
  Rectangle(0,0,mx,vga30);
  for i:=1 to 7 do Line(i*dx,0,i*dx,vga30);
  for i:=0 to 7 do putbutton(i*dx+5,ButtonTexts[i+1]);
  with GrBounds do Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);
  SetWriteMode(DrawMode)
end;

procedure DefineButtons;
var i,mx,my,dx:integer;
    vga30:integer;
begin
  RemoveButtons;
  for i:=1 to 8 do ButtonTexts[i]:=texts[i];
  mx:=GetMaxX; my:=GetMaxY;
  vga30:=round(my/16);
  dx:=mx div 8;
  Graph.SetViewport(0,my-vga30,mx,my,ClipOn);
  SetTextJustify(LeftText,BottomText);
  SetColor(ButtColor);
  SetWriteMode(Overwrite);
  Rectangle(0,0,mx,vga30);
  for i:=1 to 7 do Line(i*dx,0,i*dx,vga30);
  if UseArrowKeys then SetColor(lightred);
  Line(4*dx,0,4*dx,vga30);
  SetColor(ButtColor);
  for i:=0 to 7 do putbutton(i*dx+5,texts[i+1]);
  with GrBounds do Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);
  SetWriteMode(DrawMode)
end;

function ReadButton;
var i,mx,my,dx,vga30,x1,x2:integer;
    m1,m2,m3,m4,m5:word;
    button:integer;
begin
  mx:=GetMaxX; my:=GetMaxY;
  dx:=mx div 8;
  vga30:=round(my/16);
  m1:=7; m3:=0; m4:=mx-8;
  mouse(m1,m2,m3,m4,m5);
  m1:=8; m3:=my-vga30; m4:=my-8;
  mouse(m1,m2,m3,m4,m5);
  if OldMouseX=-1 then m3:=mx div 2 else m3:=OldMouseX;
  m1:=4; m4:=my-(vga30 div 2)-4;
  mouse(m1,m2,m3,m4,m5);
  m1:=1; mouse(m1,m2,m3,m4,m5);
  m1:=3;
  repeat mouse(m1,m2,m3,m4,m5) until m2=0;
  time_in;
  repeat
       mouse(m1,m2,m3,m4,m5);
       time_out(igeduld)
  until m2>0;
  OldMouseX:=m3;
  OldMouseY:=m4;
  result:=trunc(m3/dx)+1;
  button:=m2;
  ReadButton:=button;
  HideMouse;
  Graph.SetViewport(0,my-vga30,mx,my,ClipOn);
  case button of
    1:begin x1:=(result-1)*dx+2; x2:=trunc((result-0.25)*dx) end;
    2:begin x1:=round((result-0.75)*dx); x2:=result*dx-2 end;
    else begin x1:=round((result-0.87)*dx); x2:=trunc((result-0.13)*dx) end
  end;
  SetWriteMode(ExclOr);
  SetColor(ButtColor);
  Rectangle(x1,2,x2,vga30-2);
  mydelay(200);
  Rectangle(x1,2,x2,vga30-2);
  SetWriteMode(DrawMode);
  with GrBounds do Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);

end;

procedure Prompt;
const ixprmpt=5; iyprmpt=15;
begin
  Crt.Window(80,1,80,1); GotoXY(1,1);
  Graph.SetViewport(0,0,GetMaxX,GetMaxY,ClipOff);
  SetTextJustify(LeftText,BottomText);
  SetColor(BackColor);
  if length(OldPrmptStr)>0 then OutTextXY(ixprmpt,iyprmpt,OldPrmptStr);
  if length(OldRespStr)>0 then OutTextXY(ResponsPos,iyprmpt,OldRespStr);
  SetColor(ButtColor);
  OutTextXY(ixprmpt,iyprmpt,PromptStr);
  ResponsPos:=ixprmpt+8+length(PromptStr)*8;
  OldPrmptStr:=PromptStr;
  OldRespStr:='';
  with GrBounds do Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);
  RespDone:=false
end;

procedure Response;
const iyprmpt=15;
begin
  Crt.Window(80,1,80,1); GotoXY(1,1);
  Graph.SetViewport(0,0,GetMaxX,GetMaxY,ClipOff);
  SetTextJustify(LeftText,BottomText);
  SetColor(BackColor);
  if RespDone then
    if length(OldRespStr)>0 then
      OutTextXY(ResponsPos,iyprmpt,OldRespStr);
  SetColor(ButtColor);
  OutTextXY(ResponsPos,iyprmpt,RespStr);
  OldRespStr:=RespStr;
  with GrBounds do Graph.SetViewport(Left,Top,Right,Bottom,ClipOn);
  RespDone:=true
end;

function ReadReal;
begin
   Error('ReadReal is not implemented')
end;

function ReadInteger:integer;
begin
   Error('ReadReal is not implemented')
end;

function ReadString:string;
begin
   Error('ReadReal is not implemented')
end;

procedure SetMarkerMode;
begin
  case mode of
    Overwrite,
    ExclOr:  MarkerMode:=mode;
    else Error('only OverWrite and ExclOr modes implemented')
  end
end;

procedure SetGraphtextMode;
begin
  case mode of
    Overwrite,
    ExclOr:  GraphTextMode:=mode;
    else Error('only OverWrite and ExclOr modes implemented')
  end
end;

procedure SetFillMode;
begin
  Error('SetFillMode not implemented');
end;

procedure SetDrawMode;
begin
  DrawMode:=mode;
  case DrawMode of
    OverWrite:SetWriteMode(CopyPut);
    ExclOr   :SetWriteMode(XORPut)
    else Error('only OverWrite and ExclOr modes implemented')
  end
end;

procedure SetPaletEntry;
begin
  if (WhichPalette<1) or (WhichPalette>2) then
    Error('only user Palettes may be set');
  if (index<-1) or (index>255) then Error('invalid color index');
  if index=-1 then copyDefaultPalette(WhichPalette)
  else
    begin
      Palettes[WhichPalette].data[index][0]:=rd shr 2;
      Palettes[WhichPalette].data[index][1]:=gr shr 2;
      Palettes[WhichPalette].data[index][2]:=bl shr 2
    end
end;

procedure LoadPalette;
var regs:registers;
    i   :word;
begin
  if (WhichPalette<0) or (WhichPalette>2) then
  Error('try to load non-existing palette');
    with regs do                (* MW -- fast, but flickers *)
      begin
        AX:=$1012;
        BX:=0;
        CX:=NumColors;
        ES:=seg(Palettes[WhichPalette].data);
        DX:=ofs(Palettes[WhichPalette].data)
      end;
    intr($0010,regs)
end;

procedure ReadPalette;
begin
  if (WhichPalette<0) or (WhichPalette>2) then
    Error('non-valid palette number');
  if (index<0) or (index>=NumColors) then
    Error('color index out of range');
  rd:=Palettes[WhichPalette].data[index][0] shl 2;
  gr:=Palettes[WhichPalette].data[index][1] shl 2;
  bl:=Palettes[WhichPalette].data[index][2] shl 2
end;


END.
